package com.example.afrishop_v3.config;

import lombok.Data;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.stereotype.Component;

/**
 * @Auther: wudepeng
 * @Date: 2020/02/27
 * @Description:DPO配置类 (正式环境)
 */
@Component
@Data
@ConfigurationProperties(prefix = "dpo")
public class DpoConfiguration {

    private String createToken;
    private String verifyToken;
    private String cancelToken;
    private String companyToken;
    private String successCode;
    private String paymentApi;
    private String redirectUrl;
    private Integer serviceType;
    private String notifyUrl;
    private String backUrl;
    private String successUrl;
    private String failedUrl;
    private String mobileSuccessUrl;
    private String mobileFailedUrl;


    public String getPaymentApi() {
        return paymentApi;
    }

    public String getSuccessCode() {
        return successCode;
    }

    public String getRedirectUrl() {
        return redirectUrl;
    }

    public String getCompanyToken() {
        return companyToken;
    }

    public String getVerifyToken() {
        return verifyToken;
    }

    public String getCreateToken() {
        return createToken;
    }


    public String getNotifyUrl() {
        return notifyUrl;
    }

    public String getBackUrl() {
        return backUrl;
    }

    public Integer getServiceType() {
        return serviceType;
    }

    public String getSuccessUrl() {
        return successUrl;
    }

    public String getFailedUrl() {
        return failedUrl;
    }
}
