package com.example.afrishop_v3.models;

import lombok.Data;
import lombok.Getter;
import lombok.Setter;
import org.apache.commons.lang3.StringUtils;
import org.hibernate.annotations.DynamicUpdate;
import org.hibernate.annotations.Formula;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import java.io.Serializable;
import java.util.Date;

/**
 * 实体
 * 表名 tb_cf_address
 *
 * @author G
 * @date 2019-08-16 15:51:16
 */
@Entity
@Data
@DynamicUpdate
public class TbCfAddress {


    @Id
    private String addressId;
    /**
     * 用户id
     */
    private String userId;
    /**
     * 姓
     */
    private String deliveryName;

    private String firstName;
    /**
     * 名
     */
    private String lastName;
    /**
     * 联系电话
     */
    private String phone;
    /**
     * 邮箱
     */
    private String email;
    /**
     * 是否为默认地址
     */
    private Integer defaultFlag;
    /**
     * 地址详情1
     */
    private String addressDetail;
    private String address1;
    /**
     * 地址详情2
     */
    private String address2;
    /**
     * 国家
     */
    private String country;
    /**
     * 省
     */
    private String province;
    /**
     * 市
     */
    private String city;
    /**
     * 邮编
     */
    private String zipCode;
    /**
     * 创建时间
     */
    private Date createTime;
    /**
     * 更新时间
     */
    private Date updateTime;

    private String countryCode;
    private String userPhone;
    private String countryFlag;



    public String getAddress2() {
        if (address2 == null) {
            address2 = "";
        }
        return address2;
    }

    public String getProvince() {
        if (province == null) {
            province = "";
        }
        return province;
    }

    //    public String getDeliveryName() {
//        if (lastName != null) {
//            deliveryName += lastName;
//        }
//        return deliveryName;
//    }


//    public String getAddressDetail() {
//        StringBuffer sbuf = new StringBuffer();
//        if (country != null) {
//            sbuf.append(country);
//        }
//        if (province != null) {
//            sbuf.append(province);
//        }
//        if (city != null) {
//            sbuf.append(city);
//        }
//        if (address1 != null) {
//            sbuf.append(address1);
//        }
//        if (address2 != null) {
//            sbuf.append(address2);
//        }
//        return sbuf.toString();
//    }
}
